//---
//	print: Command-line structure printing
//---

#ifdef TEX_PRINT

#include <TeX/node.h>
#include <TeX/flow.h>
#include <TeX/env.h>

#define GRAY "\e[30;1m"
#define END "\e[0m"

/* TeX_print_node(): Print a node's tree */
void TeX_print_node(struct TeX_Node *node, int indent);

/* TeX_print_flow(): Print a flow's tree */
void TeX_print_flow(struct TeX_Flow *flow, int indent);

/* TeX_print_env(): Recursively print an environment */
void TeX_print_env(struct TeX_Env *env, int indent);

/* TeX_print_env_primary(): Print a primary environment to stdout */
void TeX_print_env_primary(struct TeX_Env *env, int indent);

/* TeX_print_lex(): Print the result of lexing */
void TeX_print_lex(char const *formula);

#endif /* TEX_PRINT */
